/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "experimenter/horizon.h"

using namespace Tk::Experimenter;

Horizon:: Horizon()
  : Gtk::VScale(0.0, 1.0, 0.1),
    _adjustment(0.75, 0.0, 1.0, 0.01, 0.1)
{
  set_digits(3);
  set_adjustment(_adjustment);
  set_draw_value();
  set_value_pos(Gtk::POS_BOTTOM);
  set_tooltip_text("Where on the screen to scroll the traces from");
}

double
Horizon:: get_horizon() const
{
  return get_value();
}
