/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <boost/variant/get.hpp>

#include "experimenter/location_selector.h"
#include "libtkdb/exception.h"

using namespace Tk::Experimenter;

LocationSelector:: LocationSelector(Db::Database *database)
  : DomainSelector(database, "location")
{
  
}

Tk::Db::Id
LocationSelector:: get_location()
{
  return get_selected().front();
}


Tk::String
LocationSelector:: render_entity(const Tk::Db::Id &entity_id)
{
  try
    {
      Tk::Db::Data::Value name( _database->get_property("location", entity_id, "name") );
      return boost::get<Tk::String>(name.get_datum().get_value());
    }
  catch (Tk::Db::PropertyNotSet pns)
    {
      return Tk::String("Location #") + Tk::String(entity_id);
    }
}
