/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libtkrandom/pristine.h"

using namespace Tk::Random;

Pristine:: Pristine(unsigned char_count, unsigned block_size)
  : _block_size(block_size),
    Block(char_count)
{
}

unsigned
Pristine:: get_block_size()
{
  return _block_size;
}

Buffer *
Pristine:: get_buffer(unsigned char_count)
{
  Buffer *buf( new Buffer() );
  for (unsigned i(0); i < char_count; ++i)
    buf->push_back(static_cast<char>(0x55));
  
  return buf;
}

bool
PristineType:: is_true_randomness()
{
  return false;
}

Retriever *
PristineType:: new_retriever(unsigned count)
{
  return new Pristine(count);
}
