/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004,2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_RANDOM_RETRIEVER_H__
#define __TK_RANDOM_RETRIEVER_H__

#include <memory>

#include "libtkrandom/types.h"

namespace Tk {
  namespace Random {
    
    class Collector
    {
    public:
      /** return false to finish retrieving */
      virtual bool collect(Buffer *buffer) = 0;
    };
    
    class Retriever
    {
    private:
      /** Whether or not the retriever should run forever */
      bool     _limited;
    protected:
      unsigned _remaining;
      bool limited();
    public:
      /** Passing a count of zero means the retriever will run until
	  the collector returns false */
      Retriever(unsigned char_count);
      virtual void retrieve(Collector &collector) = 0;
    };
    
    typedef std::auto_ptr<Retriever> RetrieverPtr;
    
  }; /* namespace Random */
}; /* namespace Tk */


#endif /* __TK_RANDOM_RETRIEVER_H__ */
