/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_RANDOM_TYPES_H__
#define __TK_RANDOM_TYPES_H__

#include <vector>
#include <limits>
#include <string>
#include <sstream>
#include <wchar.h>

#include "libtkcommon/stream.h"

namespace Tk {
  
  namespace Random {

#ifdef ODBCXX_UNICODE
    typedef wchar_t BitChar;
#else    
    typedef char BitChar;
#endif /* ODBCXX_UNICODE */

    typedef std::vector<BitChar> Buffer;

    template <typename C>
    unsigned short bits_per_char()
    {
      return std::numeric_limits<C>::digits + static_cast<unsigned short>(std::numeric_limits<C>::is_signed);
    }
    
    /*
    static const unsigned short BITS_PER_CHAR =
      std::numeric_limits<BitChar>::digits + static_cast<unsigned short>(std::numeric_limits<BitChar>::is_signed);
    */
    
    static const unsigned short BITS_PER_CHAR = bits_per_char<BitChar>();
    
  }; /* namespace Random */
  
}; /* namespace Tk */


#endif /* __TK_RANDOM_TYPES_H__ */
